using System;
using System.Windows.Forms;
using System.Reflection;
using System.IO;

namespace DigitaAdvantage.ClickOnce
{
    public delegate void CheckLibraryClassDelegate();

    public sealed class ClickOnceAssembly
    {
        private string currentDllName;
        private string currentFolderPath;
        private CheckLibraryClassDelegate CheckLibraryClass;

        public ClickOnceAssembly()
        {
            currentDllName = "";
            currentFolderPath = "";
        }
   
        /// <summary>
        /// ClickOnceŃIf}hzuNX Cui.dllt@CjCLRɃ[h܂B
        /// </summary>
        /// <param name="folderPath">.dllt@CzuꂽtH_w肵܂Bʏ́uApplication.StartupPathvŎ擾pXɂȂ܂B</param>
        /// <param name="dllName">.dllt@C̖Ow肵܂Bu.dllvƂgq͊܂߂Ɏw肵ĂB</param>
        /// <returns>̃[hꂽꍇ</returns>
        public bool LoadDeployedFile(string folderPath, string dllName, CheckLibraryClassDelegate checkMethod)
        {
            currentDllName = dllName;
            currentFolderPath = folderPath;
            CheckLibraryClass = checkMethod;

            // AZu̓ǂݍ݂sƂɔAssemblyResolveCxgd|Ă
            ResolveEventHandler myResolveEventHandler = new ResolveEventHandler(DynamicDll_AssemblyResolve);
            AppDomain.CurrentDomain.AssemblyResolve += myResolveEventHandler;

            try
            {
                // ʏCLR@\ŎIɃ[h邪AłG[ꍇAssemblyResolveCxgŎ蓮Ń[hȂ
                CheckLibraryClass();
            }
            catch (FileNotFoundException)
            {
                return false;   // ܂ɃAZu̓ǂݍ݂sĂ̗O
            }
            catch (Exception)
            {
                return false;
            }
            finally
            {
                AppDomain.CurrentDomain.AssemblyResolve -= myResolveEventHandler;
                currentDllName = "";
                currentFolderPath = "";
                CheckLibraryClass = null;
            }

            return true;
        }

        Assembly DynamicDll_AssemblyResolve(object sender, ResolveEventArgs args)
        {
            // ̃Cxg nhCLRɂAZuǂݍ݂ɎsƌĂяo
            // ǂݍރAZuw̃AZuꉞ`FbN
            string[] nameParts = args.Name.Split(',');
            if (nameParts[0] != currentDllName)
            {
                return null;
            }

            // CLR̃LbVɈȑÕAZu̓ǂݍݎs̗cĂ邽
            // Assembly.Load\bh͎gȂƂɒӂ邱ƁB
            return Assembly.LoadFile(currentFolderPath + "\\" + currentDllName + ".dll");
        }

    }

}
