﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Reflection;
using System.IO;
using DigitaAdvantage.ClickOnce;

namespace DigitaAdvantage.ClickOnce.Forms
{
    internal partial class ConnectingPane : MainPane
    {
        public bool cancelled;
        private Form parentMainForm;

        public ConnectingPane(Form parentForm)
        {
            parentMainForm = parentForm;

            Assembly asm = DeploymentUtil.GetSystemDeploymentAssembly();
            Stream stream = asm.GetManifestResourceStream("splash.gif");

            cancelled = false;

            InitializeComponent();

            pictureBoxWait.Image = new Bitmap(stream);

            parentForm.SuspendLayout();
            parentForm.Text = "アプリケーション コンポーネントの確認中";
            parentForm.MinimizeBox = false;
            parentForm.MaximizeBox = false;
            parentForm.ControlBox = true;
            parentForm.ResumeLayout(false);
            parentForm.PerformLayout();
        }

        public override bool OnClosing()
        {
            bool ret = base.OnClosing();
            base.IsCanceled = true;
            return ret;
        }
    }
}
