#define ENABLE_ClickOnceAppDeployment  // ApplicationDeploymentNXpꍇ́A̍sRgAEgĂB

#if ENABLE_ClickOnceAppDeployment
using DigitaAdvantage.ClickOnce;
#else
using System.Deployment.Application;
using ClickOnceAppDeployment = System.Deployment.Application.ApplicationDeployment;
using DigitaAdvantage.ClickOnce;
#endif

using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Threading;
using System.Diagnostics;
using System.Runtime.CompilerServices;

using SampleClassLibrary;

namespace SampleApplication
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();

            this.Text = Application.ProductName;
        }

        #region ClickOnceƂ̌Ăяo
        private void buttonOnDemand_Click(object sender, EventArgs e)
        {
            if (MyDownloadFileGroup("SampleClassLibraryGroup"))
            {
                if (LoadSampleClassLibrary())
                {
                    UseSampleClassLibrary();
                }
                else
                {
                    MessageBox.Show("̋@\͌ݗpł܂B\nSampleClassLibrary_E[hĂȂ\܂B");
                }
            }
            else
            {
                MessageBox.Show("SampleClassLibrary_E[hĂȂ߁A\n̋@\͌ݗpł܂B");
            }
        }

        private void buttonUpdate_Click(object sender, EventArgs e)
        {
            MyUpdate();
        }
        #endregion

        private bool MyDownloadFileGroup(string groupName)
        {
            if (ClickOnceAppDeployment.IsNetworkDeployed)
            {
                ClickOnceAppDeployment deploy = ClickOnceAppDeployment.CurrentDeployment;

                if (deploy.IsFileGroupDownloaded(groupName) == false)
                {
                    deploy.DownloadFileGroup(groupName);
#if ENABLE_ClickOnceAppDeployment
                    switch (deploy.ProcessingMode)
                    {
                        case ProcessingMode.Canceled:
                            MessageBox.Show("LZ܂B");
                            break;

                        case ProcessingMode.Error:
                            // G[EbZ[WDownloadFileGroup\bhŕ\ς݁B
                            break;

                        case ProcessingMode.Completed:
                            // O[ṽ_E[hɐI
                            return true;

                        default:
                            Debug.Assert(false);
                            break;
                    }
#endif
                }
                else
                {
                    // ̃O[v͂łɃCXg[Ă܂B
                    return true;
                }
            }
            else
            {
                // ClickOnceŔzuꂽAvP[Vł͂Ȃ̂
                // _E[hɃR|[lg𗘗pł܂B
                return true;
            }
            return false;
        }

        // If}hŎ擾AZui.dllt@Cj[h
        private bool LoadSampleClassLibrary()
        {
            ClickOnceAssembly asm = new ClickOnceAssembly();
            return asm.LoadDeployedFile(
                Application.StartupPath, "SampleClassLibrary",
                new CheckLibraryClassDelegate(asm_CheckLibraryClassDelegate));
        }

        // AZu[h邽߂̃fQ[g \bh
        [MethodImpl(MethodImplOptions.NoInlining)]
        void asm_CheckLibraryClassDelegate()
        {
            SampleClassLibraryCheckClass dummy = new SampleClassLibraryCheckClass();
        }

        // If}hzuR[h̓\bhɂ܂Ƃ߂
        [MethodImpl(MethodImplOptions.NoInlining)]
        private void UseSampleClassLibrary()
        {
            // O[ṽR[hs
            DownloadedDialog dlg = new DownloadedDialog();
            dlg.ShowDialog();
        }

        private void MyUpdate()
        {
            if (ClickOnceAppDeployment.IsNetworkDeployed)
            {
                ClickOnceAppDeployment deploy = ClickOnceAppDeployment.CurrentDeployment;

                if (deploy.CheckForUpdate())
                {
                    bool isUpdated = false;
#if ENABLE_ClickOnceAppDeployment
                    // [U[ɍXV̊mF\čXVs܂B
                    isUpdated = deploy.Update(deploy.IsUpdateRequired); 
#else
                    // \ɍXVs܂B
                    isUpdated = deploy.Update(); 
#endif
                    if (isUpdated)
                    {
                        DialogResult dret = MessageBox.Show(
                            "AvP[V͍XV܂B\n" + 
                            "AvP[VVo[Wɐ؂ւɂ" + 
                            "ݎs̃AvP[VċNKv܂B\n\n" + 
                            "AvP[VċN܂H\n" + 
                            "iOS͍ċN܂Bj",
                            "ċN܂H",
                            MessageBoxButtons.YesNo, MessageBoxIcon.Question);
                        if (dret == DialogResult.Yes)
                        {
                            Application.Restart();
                        }
                    }
                    else
                    {
#if ENABLE_ClickOnceAppDeployment
                        switch (deploy.ProcessingMode)
                        {
                            case ProcessingMode.Canceled:
                                MessageBox.Show("LZ܂B");
                                break;

                            case ProcessingMode.Skipped:
                                MessageBox.Show("XLbv܂B");
                                break;

                            case ProcessingMode.Error:
                                // G[EbZ[WUpdate\bhŕ\ς݁B
                                break;

                            default:
                                Debug.Assert(false);
                                break;
                        }
#endif
                    }
                }
                else
                {
#if ENABLE_ClickOnceAppDeployment
                    switch (deploy.ProcessingMode)
                    {
                        case ProcessingMode.Canceled:
                            MessageBox.Show("LZ܂B");
                            break;

                        case ProcessingMode.Error:
                            // G[EbZ[WCheckForUpdate\bhŕ\ς݁B
                            break;

                        case ProcessingMode.Completed:
                            MessageBox.Show("XV̕Kv͂܂B");
                            break;

                        default:
                            Debug.Assert(false);
                            break;
                    }
#endif
                }
            }
            else
            {
                MessageBox.Show("ClickOnceŔzuꂽAvP[Vł͂܂B");
            }
        }
    }
}