using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Deployment.Application;
using System.Reflection;

namespace SampleClassLibrary
{
    public partial class DownloadedDialog : Form
    {
        public DownloadedDialog()
        {
            InitializeComponent();
        }

        private void DownloadedDialog_Load(object sender, EventArgs e)
        {
            SetDeploymenInformation();
        }

        private void buttonClose_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        private void SetDeploymenInformation()
        {
            if (ApplicationDeployment.IsNetworkDeployed)
            {
                ApplicationDeployment ad = ApplicationDeployment.CurrentDeployment;

                StringBuilder sb = new StringBuilder();

                if (ad.ActivationUri != null)
                {
                    sb.Append("ActivationUri: " + ad.ActivationUri.AbsoluteUri.ToString() + "\r\n");
                }
                else
                {
                    sb.Append("ActivationUri: URLp[^AvP[VɓnƂĂ܂B\r\n");
                }
                sb.Append("CurrentVersion: " + ad.CurrentVersion.ToString() + "\r\n");
                sb.Append("DataDirectory: " + ad.DataDirectory.ToString() + "\r\n");
                sb.Append("IsFirstRun: " + ad.IsFirstRun.ToString() + "\r\n");
                sb.Append("IsNetworkDeployed: " + ApplicationDeployment.IsNetworkDeployed.ToString() + "\r\n");
                sb.Append("TimeOfLastUpdateCheck: " + ad.TimeOfLastUpdateCheck.ToString() + "\r\n");
                sb.Append("UpdatedApplicationFullName: " + ad.UpdatedApplicationFullName.ToString() + "\r\n");
                sb.Append("UpdatedVersion: " + ad.UpdatedVersion.ToString() + "\r\n");
                sb.Append("UpdateLocation: " + ad.UpdateLocation.ToString() + "\r\n");

                this.textBox1.Text = sb.ToString();

                /*
 -ActivationUri AvP[V̔zu}jtFXgN邽߂Ɏgp URL 擾܂B
1.0.0.19 -CurrentVersion AvP[V̌ݎs̃CX^X̔zũo[W擾܂B  
C:\Documents and Settings\masa-i.D-ADVANTAGE\Local Settings\Apps\2.0\Data\OZ8MB383.668\CH4AA81L.9Q7\samp..tion_5996c692db4c640c_0001.0000_07d4954d4b093b70\Data -DataDirectory ClickOnce f[^ fBNgւ̃pX擾܂B  
True -IsFirstRun NCAg Rs[^ł̃AvP[Vŝ͍񂪏߂Ăǂl擾܂B  
True -IsNetworkDeployed ݂̃AvP[V ClickOnce AvP[Vǂl擾܂B  
2006/03/19 15:43:07 -IsNetworkDeployed ClickOnce AvP[V̍XVŌɃ`FbN擾܂B  
http://dapc89/SampleApplication/SampleApplication.application#SampleApplication.application, Version=1.0.0.19, Culture=neutral, PublicKeyToken=5996c692db4c640c, processorArchitecture=msil/SampleApplication.exe, Version=1.0.0.19, Culture=neutral, PublicKeyToken=5996c692db4c640c, processorArchitecture=msil, type=win32 -UpdatedApplicationFullName AvP[V̍XVɁAAvP[V̊S擾܂B  
1.0.0.19 -UpdatedVersion ŋ߃_E[hꂽXṼo[W擾܂B  
http://dapc89/SampleApplication/SampleApplication.application -UpdateLocation ̃AvP[V̍XVł Web TCg܂̓t@CL擾܂B  
                 */
            }
            else
            {
                this.textBox1.Text = "ClickOnceŔzzĂȂ̂ŁAfvCg͂܂B";
            }
        }

        private string GetExecutingAssemblyPath()
        {
            Assembly assembly1 = Assembly.GetExecutingAssembly();
            return assembly1.Location;
        }
    }
}